Uses Dos,Crt;

{----------------------------------------------------------------------------}

Const
  MaxEvents = 100;

Var
  Events    : Byte;
  Event     : Array[1..MaxEvents] of Record
                                       Time       : Word;
                                       Days       : String[7];
                                       Errorlevel : Byte;
                                     End;

  T         : Text;
  S         : String;
  x,y       : Word;
  R         : Registers;
  Windows   : Boolean;
  Now       : Word;
  ToDay     : Byte;
  LastEvent : Byte;
  NextEvent : Byte;
  Ch        : Char;
  DoToday   : Boolean;
  Loaded    : Boolean;
  b         : Byte;
  F         : File of Byte;
  LastTime  : String[20];

{----------------------------------------------------------------------------}

  Function GrabWord(S: String; B: Byte) : String;
  Var st,e:Byte;
      return : String[80];
  Begin
    Return:='';
    st:=1;e:=1;
    While B>0 Do
    Begin
      While (S[st]=' ') or (S[st]=#9) Do Inc(st);  { #9 er TAB }
      e:=st;
      While (S[e]<>' ') And (e<=Length(s)) And (e<255) Do Inc(e);
      Return:=Copy(S,st,e-st);
      st:=e;
      Dec(B);
    End;
    GrabWord:=Return;
  End;

  Function StrToInt(S: String) : LongInt;
  Var
    Kode : Integer;
    i    : LongInt;
    R    : Real;
  Begin
    If s='' Then
    Begin
      StrToInt:=0;
      Exit;
    End;
    i:=1; While s[i] in ['-','0'..'9'] Do Inc(i);
    Delete(s,i,255);
    If Length(S) = 0 Then StrToInt := 0 Else Begin
      Val(S,i,Kode);
      If Kode = 0 Then StrToInt := i Else
      Begin
        Val(S,R,Kode);
        If (Kode = 0) And (R<MaxLongint) Then StrToInt := Trunc(R) Else StrToInt:=0;
      End;
    End;
  End;

  Function IntToNulStr(i: LongInt;b:Byte): String;
  { Heltal->streng 40,3 = '040'  9,4 = '0009' etc.  }
  Var
    S    : String[11];
  Begin
    Str(i, S);
    While Length(S)<b Do S:='0'+S;
    If Length(S)>b Then S:='?'+Copy(S,Length(S)-b+2,10);
    IntToNulStr:=S;
  End;

  Function TimeNow : Word;
  Var
    ho,mi,se,sec100  : Word;    { Dato var }
  Begin
    GetTime(ho,mi,se,sec100);
    TimeNow:=ho*60+mi;
  End;

  Function Dayofweek:Byte;
  Var
    ye, mo, da, dow  : Word;    { Dato var }
  Begin
    GetDate(ye,mo,da,dow);
    Dayofweek:=dow+1;
  End;

  Function TimeSekStr : String;                 { Retur Tid i 12:00:03 format     }
  Var
    t:string[10];
    ho,mi,se,sec100: Word;    { Dato var }
  Begin
    GetTime(ho,mi,se,sec100);
    TimeSekStr:=IntToNulStr(ho,2)+':'+IntToNulStr(mi,2)+':'+IntToNulStr(se,2)
  End;

  Function NumChar(Ch : Char; Lgd : Byte): String;
  { Returner string with x chars }
  Var
    s:String;
  Begin
    If Lgd>132 Then Lgd:=132;
    FillChar(S[1], Lgd, Ch);
    S[0] := Char(Lgd);
    NumChar:=S;
  End;

{----------------------------------------------------------------------------}

Procedure LoadEvents;
Begin
  Window(1,1,80,25);

  Assign(T,'EVENTER.CFG');
  {$I-} Reset(T); {$I+}
  If IOResult<>0 Then
  Begin
    WriteLn('EVENTER.CFG not found in current directory');
    Halt;
  End;

  Textattr:=7;
  ClrScr;
  Textattr:=14;
  GotoXY(10,1);
  WriteLn('Simply Event Errorlevel utility by Bo Bendtsen *FREEWARE*');
  Textattr:=1;

  Textattr:=23;
  GotoXY(1,2);
  Write(numchar('',80));
  For x:=3 To 20 Do
  Begin
    GotoXY(1,x);
    write(numchar(' ',80));
  End;
  GotoXY(1,2);
  Write(numchar('',80));
  GotoXY(1,21);
  Write(numchar('',80));
  Window(2,3,79,20);
  GotoXY(1,1);

  WriteLn;
  Windows:=False;
  With R Do
  Begin
    AX:=$4680; Intr($2F,R);
    If AX=0 Then Windows:=True
    Else Begin
      AX:=$160A; BX:=0; Intr($2F,R);
      If BX<>0 Then
      Begin
        Windows:=True;
      End;
    End;
  End;

  If Windows Then
  Begin
    Textattr:=31;
    GotoXY(1,1);
    Write('Windows detected');
  End;

  Events:=0;

  LastEvent:=0;
  Assign(F,'EVENTER.LST');
  {$I-} reset(f); {$I+}
  If IOResult=0 Then
  Begin
    Read(f,LastEvent);
    Close(F);
  End;

  GotoXY(1,3);

  Textattr:=23;
  WriteLn('Num Time Days    Errorlevel');
  Textattr:=25;
  WriteLn('   ');
  Textattr:=26;

  While Not Eof(T) and (Events<MaxEvents) Do
  Begin
    ReadLn(T,s);
    If (s<>'') and (s[1]<>'%') Then
    Begin
      Inc(Events);
      If Events<20 Then
        WriteLn(Inttonulstr(Events,3)+' '+Grabword(s,1)+' '+Grabword(s,2)+' '+Grabword(s,3));
      Event[Events].Time:=Strtoint(Copy(Grabword(s,1),1,2))*60+StrToInt(Copy(Grabword(s,1),3,2));
      Event[Events].Days:=Grabword(s,2);
      Event[Events].Errorlevel:=Strtoint(Grabword(s,3));
    End;
  End;
  Close(T);

  Today:=Dayofweek;
  Now:=TimeNow;

  NextEvent:=0;
  DoToday:=True;

  For x:=1 To Events Do
    If (Event[x].Time>Now) And
       (
        (Lastevent=0) or
        (Lastevent<>x)
       ) And
       (
        (NextEvent=0) Or
        (Event[x].Time<Event[NextEvent].Time) And (Event[x].Days[Today]='+')
       ) Then
         NextEvent:=x;

  If NextEvent=0 Then
    For x:=1 To Events Do
      If (Event[x].Time<=Now) And
         (
          (NextEvent=0) Or
          (Event[x].Time<Event[NextEvent].Time) And (Event[x].Days[Today]='+')
         ) Then
      Begin
        NextEvent:=x;
        DoToday:=False;
      End;

  Textattr:=30;
  Writeln;
  WriteLn('Next event ',Nextevent);

  Window(1,1,80,25);
  GotoXY(1,1);

End;

Begin

  LoadEvents;

  Ch:=#0;
  Textattr:=12;
  Loaded:=False;

  LastTime:='';

  Repeat

    If Lasttime<>Timesekstr Then
    Begin
      Lasttime:=Timesekstr;
      GotoXY(73,1);
      Write(Lasttime);
      GotoXY(1,1);
    End;

    If Windows Then
      Inline($B8/$80/$16/$cd/$2F);
    If Keypressed then ch:=Readkey;

    If Loaded And (TimeNow=0) Then ;
    If Loaded And (TimeNow=1) Then Loaded:=False
    Else If Not Loaded And (TimeNow=0) Then
    Begin
      Loaded:=True;
      Assign(F,'EVENTER.LST');
      {$I-} erase(f); {$I+}
      If IOResult=0 Then ;
      LoadEvents;
    End;

  Until (ch=#27) or
        (Dotoday and (TimeNow>=Event[Nextevent].Time)) Or
        (Not Dotoday and (TimeNow<Event[Nextevent].Time));

  If ch=#27 Then
  Begin
    Textattr:=7;
    Clrscr;
    s:='0';
    WriteLn('Exit with what errorlevel (RETURN=0) ?');
    Write(s+#13);
    Readln(s);
    Halt(StrToint(s));
  End
  Else Begin
    Textattr:=7;
    Clrscr;
    WriteLn('Exiting with errorlevel ',Event[Nextevent].Errorlevel);
    Halt(Event[Nextevent].Errorlevel);
    Assign(F,'EVENTER.LST');
    rewrite(f);
    Write(f,Event[Nextevent].Errorlevel);
    Close(F);
    Halt(Event[Nextevent].Errorlevel);
  End;

End.